diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr.c olsrd-current/src/olsr.c
--- olsrd-0.5.0/src/olsr.c	2007-02-04 23:47:45.000000000 +0100
+++ olsrd-current/src/olsr.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsr.c,v 1.50 2007/02/04 22:47:45 bernd67 Exp $
+ * $Id: olsr.c,v 1.54 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 /**
@@ -88,7 +88,7 @@
  *Initialize the message sequence number as a random value
  */
 void
-init_msg_seqno()
+init_msg_seqno(void)
 {
   message_seqno = random() & 0xFFFF;
 }
@@ -98,8 +98,8 @@
  *
  *@return the seqno
  */
-inline olsr_u16_t
-get_msg_seqno()
+olsr_u16_t
+get_msg_seqno(void)
 {
   return message_seqno++;
 }
@@ -110,7 +110,7 @@
 {
   struct pcf *new_pcf;
 
-  OLSR_PRINTF(1, "Registering pcf function\n")
+  OLSR_PRINTF(1, "Registering pcf function\n");
 
   new_pcf = olsr_malloc(sizeof(struct pcf), "New PCF");
 
@@ -129,18 +129,17 @@
  *@return 0
  */
 void
-olsr_process_changes()
+olsr_process_changes(void)
 {
-
   struct pcf *tmp_pc_list;
 
 #ifdef DEBUG
   if(changes_neighborhood)
-    OLSR_PRINTF(3, "CHANGES IN NEIGHBORHOOD\n")
+    OLSR_PRINTF(3, "CHANGES IN NEIGHBORHOOD\n");
   if(changes_topology)
-    OLSR_PRINTF(3, "CHANGES IN TOPOLOGY\n")
+    OLSR_PRINTF(3, "CHANGES IN TOPOLOGY\n");
   if(changes_hna)
-    OLSR_PRINTF(3, "CHANGES IN HNA\n")
+    OLSR_PRINTF(3, "CHANGES IN HNA\n");
 #endif
   
   if(!changes_force &&
@@ -255,9 +254,8 @@
  *Also initalizes other variables
  */
 void
-olsr_init_tables()
-{
-  
+olsr_init_tables(void)
+{  
   changes_topology = OLSR_FALSE;
   changes_neighborhood = OLSR_FALSE;
   changes_hna = OLSR_FALSE;
@@ -290,15 +288,9 @@
   olsr_init_mid_set();
 
   /* Initialize HNA set */
-  olsr_init_hna_set();
-  
+  olsr_init_hna_set();  
 }
 
-
-
-
-
-
 /**
  *Check if a message is to be forwarded and forward
  *it if necessary.
@@ -325,17 +317,18 @@
   if(!olsr_check_dup_table_fwd(originator, seqno, &in_if->ip_addr))
     {
 #ifdef DEBUG
-      OLSR_PRINTF(3, "Message already forwarded!\n")
+      OLSR_PRINTF(3, "Message already forwarded!\n");
 #endif
       return 0;
     }
 
   /* Lookup sender address */
-  if(!(src = mid_lookup_main_addr(from_addr)))
+  src = mid_lookup_main_addr(from_addr);
+  if(!src)
     src = from_addr;
 
-
-  if(NULL == (neighbor=olsr_lookup_neighbor_table(src)))
+  neighbor=olsr_lookup_neighbor_table(src);
+  if(!neighbor)
     return 0;
 
   if(neighbor->status != SYM)
@@ -349,12 +342,11 @@
   if(olsr_lookup_mprs_set(src) == NULL)
     {
 #ifdef DEBUG
-      OLSR_PRINTF(5, "Forward - sender %s not MPR selector\n", olsr_ip_to_string(src))
+      OLSR_PRINTF(5, "Forward - sender %s not MPR selector\n", olsr_ip_to_string(src));
 #endif
       return 0;
     }
 
-
   /* Treat TTL hopcnt */
   if(olsr_cnf->ip_version == AF_INET)
     {
@@ -369,14 +361,10 @@
       m->v6.ttl--; 
     }
 
-
-
   /* Update dup forwarded */
   olsr_set_dup_forward(originator, seqno);
 
   /* Update packet data */
-
-
   msgsize = ntohs(m->v4.olsr_msgsize);
 
   /* looping trough interfaces */
@@ -387,37 +375,33 @@
 	  /*
 	   * Check if message is to big to be piggybacked
 	   */
-	  if(net_outbuffer_push(ifn, (olsr_u8_t *)m, msgsize) != msgsize)
+	  if(net_outbuffer_push(ifn, m, msgsize) != msgsize)
 	    {
 	      /* Send */
 	      net_output(ifn);
 	      /* Buffer message */
 	      set_buffer_timer(ifn);
 	      
-	      if(net_outbuffer_push(ifn, (olsr_u8_t *)m, msgsize) != msgsize)
+	      if(net_outbuffer_push(ifn, m, msgsize) != msgsize)
 		{
-		  OLSR_PRINTF(1, "Received message to big to be forwarded in %s(%d bytes)!", ifn->int_name, msgsize)
+		  OLSR_PRINTF(1, "Received message to big to be forwarded in %s(%d bytes)!", ifn->int_name, msgsize);
 		  olsr_syslog(OLSR_LOG_ERR, "Received message to big to be forwarded on %s(%d bytes)!", ifn->int_name, msgsize);
 		}
-
 	    }
 	}
-      
       else
 	{
 	  /* No forwarding pending */
 	  set_buffer_timer(ifn);
 	  
-	  if(net_outbuffer_push(ifn, (olsr_u8_t *)m, msgsize) != msgsize)
+	  if(net_outbuffer_push(ifn, m, msgsize) != msgsize)
 	    {
-	      OLSR_PRINTF(1, "Received message to big to be forwarded in %s(%d bytes)!", ifn->int_name, msgsize)
+	      OLSR_PRINTF(1, "Received message to big to be forwarded in %s(%d bytes)!", ifn->int_name, msgsize);
 	      olsr_syslog(OLSR_LOG_ERR, "Received message to big to be forwarded on %s(%d bytes)!", ifn->int_name, msgsize);
 	    }
 	}
     }
-
   return 1;
-
 }
 
 
@@ -431,13 +415,10 @@
   jitter *= olsr_cnf->max_jitter;
 
   ifn->fwdtimer = GET_TIMESTAMP(jitter*1000);
-
 }
 
-
-
 void
-olsr_init_willingness()
+olsr_init_willingness(void)
 {
   if(olsr_cnf->willingness_auto)
     olsr_register_scheduler_event(&olsr_update_willingness, 
@@ -445,18 +426,16 @@
 }
 
 void
-olsr_update_willingness(void *foo)
+olsr_update_willingness(void *foo __attribute__((unused)))
 {
-  int tmp_will;
-
-  tmp_will = olsr_cnf->willingness;
+  int tmp_will = olsr_cnf->willingness;
 
   /* Re-calculate willingness */
   olsr_cnf->willingness = olsr_calculate_willingness();
 
   if(tmp_will != olsr_cnf->willingness)
     {
-      OLSR_PRINTF(1, "Local willingness updated: old %d new %d\n", tmp_will, olsr_cnf->willingness)
+      OLSR_PRINTF(1, "Local willingness updated: old %d new %d\n", tmp_will, olsr_cnf->willingness);
     }
 }
 
@@ -470,7 +449,7 @@
  */
 
 olsr_u8_t
-olsr_calculate_willingness()
+olsr_calculate_willingness(void)
 {
   struct olsr_apm_info ainfo;
 
@@ -582,7 +561,7 @@
 void
 olsr_exit(const char *msg, int val)
 {
-  OLSR_PRINTF(1, "OLSR EXIT: %s\n", msg)
+  OLSR_PRINTF(1, "OLSR EXIT: %s\n", msg);
   olsr_syslog(OLSR_LOG_ERR, "olsrd exit: %s\n", msg);
   fflush(stdout);
   olsr_cnf->exit_value = val;
@@ -607,9 +586,10 @@
 
   if((ptr = malloc(size)) == 0) 
     {
-      OLSR_PRINTF(1, "OUT OF MEMORY: %s\n", strerror(errno))
-      olsr_syslog(OLSR_LOG_ERR, "olsrd: out of memory!: %m\n");
-      olsr_exit((char *)id, EXIT_FAILURE);
+      const char * const err_msg = strerror(errno);
+      OLSR_PRINTF(1, "OUT OF MEMORY: %s\n", err_msg);
+      olsr_syslog(OLSR_LOG_ERR, "olsrd: out of memory!: %s\n", err_msg);
+      olsr_exit(id, EXIT_FAILURE);
     }
   return ptr;
 }
@@ -624,17 +604,12 @@
 int
 olsr_printf(int loglevel, char *format, ...)
 {
-  va_list arglist;
-
   if((loglevel <= olsr_cnf->debug_level) && debug_handle)
     {
+      va_list arglist;
       va_start(arglist, format);
-      
       vfprintf(debug_handle, format, arglist);
-      
       va_end(arglist);
     }
-
-
   return 0;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_cfg.h olsrd-current/src/olsr_cfg.h
--- olsrd-0.5.0/src/olsr_cfg.h	2006-04-17 20:31:09.000000000 +0200
+++ olsrd-current/src/olsr_cfg.h	2007-05-14 00:23:55.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsr_cfg.h,v 1.30 2006/04/17 18:31:09 kattemat Exp $
+ * $Id: olsr_cfg.h,v 1.31 2007/05/13 22:23:55 bernd67 Exp $
  */
 
 
@@ -132,7 +132,6 @@
 {
   char                     *name;
   char                     *config;
-  int                      index;
   olsr_bool                configured;
   olsr_bool                host_emul;
   union olsr_ip_addr       hemu_ip;
@@ -223,7 +222,6 @@
   struct ipc_host          *ipc_hosts;
   struct ipc_net           *ipc_nets;
   struct olsr_if           *interfaces;
-  olsr_u16_t               ifcnt;
 
   /* Stuff set by olsrd */
   size_t                   ipsize;               /* Size of address */
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsrd_plugin.h olsrd-current/src/olsrd_plugin.h
--- olsrd-0.5.0/src/olsrd_plugin.h	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-current/src/olsrd_plugin.h	2007-04-20 15:46:04.000000000 +0200
@@ -29,7 +29,7 @@
  *
  */
 
-/* $Id: olsrd_plugin.h,v 1.1 2005/05/29 12:47:45 br1 Exp $ */
+/* $Id: olsrd_plugin.h,v 1.2 2007/04/20 13:46:04 bernd67 Exp $ */
 
 /*
  * Example plugin for olsrd.org OLSR daemon
@@ -48,6 +48,13 @@
  *                Functions that the plugin MUST provide                    *
  ****************************************************************************/
 
+#if 1
+/* We hide them from the compiler here to allow the plugins itself to declare them
+ * as they also implement them if we activate -Wredundant-decls.
+ * Normally we leave it seen so that we enforce a check by the compiler if they are
+ * identical.
+ */
+
 /**
  * Plugin interface version
  * Used by main olsrd to check plugin interface version
@@ -70,6 +77,6 @@
  */
 int
 olsrd_plugin_init(void);
-
+#endif
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr.h olsrd-current/src/olsr.h
--- olsrd-0.5.0/src/olsr.h	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/olsr.h	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsr.h,v 1.25 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: olsr.h,v 1.26 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 
@@ -60,7 +60,7 @@
 void
 init_msg_seqno(void);
 
-inline olsr_u16_t
+olsr_u16_t
 get_msg_seqno(void);
 
 int
@@ -101,6 +101,6 @@
 olsr_malloc(size_t, const char *);
 
 int
-olsr_printf(int, char *, ...);
+olsr_printf(int, char *, ...) __attribute__((format(printf,2,3)));
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_protocol.h olsrd-current/src/olsr_protocol.h
--- olsrd-0.5.0/src/olsr_protocol.h	2006-01-12 12:00:49.000000000 +0100
+++ olsrd-current/src/olsr_protocol.h	2007-04-22 22:25:48.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsr_protocol.h,v 1.21 2006/01/12 11:00:49 kattemat Exp $
+ * $Id: olsr_protocol.h,v 1.22 2007/04/22 20:25:48 bernd67 Exp $
  */
 
 /*
@@ -253,7 +253,7 @@
 } __attribute__ ((packed));
 
 
-struct tcmsg 
+struct olsr_tcmsg 
 {
   olsr_u16_t        ansn;
   olsr_u16_t        reserved;
@@ -272,7 +272,7 @@
 } __attribute__ ((packed));
 
 
-struct tcmsg6
+struct olsr_tcmsg6
 {
   olsr_u16_t           ansn;
   olsr_u16_t           reserved;
@@ -373,7 +373,7 @@
   union 
   {
     struct hellomsg hello;
-    struct tcmsg    tc;
+    struct olsr_tcmsg    tc;
     struct hnamsg   hna;
     struct midmsg   mid;
   } message;
@@ -397,7 +397,7 @@
   union 
   {
     struct hellomsg6 hello;
-    struct tcmsg6    tc;
+    struct olsr_tcmsg6    tc;
     struct hnamsg6   hna;
     struct midmsg6   mid;
   } message;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_switch/commands.h olsrd-current/src/olsr_switch/commands.h
--- olsrd-0.5.0/src/olsr_switch/commands.h	2005-06-04 23:07:33.000000000 +0200
+++ olsrd-current/src/olsr_switch/commands.h	2007-05-31 02:16:52.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: commands.h,v 1.7 2005/06/04 21:07:33 kattemat Exp $
+ * $Id: commands.h,v 1.8 2007/05/31 00:16:52 ipo23 Exp $
  */
 
 
@@ -76,7 +76,7 @@
     },
     { "olsrd", "olsrd [start|stop|show|setb|seta] [IP|path|args]",
       "Start or stop local olsrd processes. Also used to set the olsrd binary path and arguments",
-      "This command is used for managing local olsrd instances from within olsr_switch.\nThe command can be configured in runtime using the setb and seta sub-commands.\nTo show the current olsrd command-configuration do:\nolsrd show\nTo set the olsrd binary path do:\nolsrd setb /full/path/to/olsrd\nTo start a olsrd instance with a IP address of 10.0.0.1, do:\nolsrd start 10.0.0.1\nTo stop that same instance do:\nolsrd stop 10.0.0.1\n",
+      "This command is used for managing local olsrd instances from within olsr_switch.\nThe command can be configured in runtime using the setb and seta sub-commands.\nTo show the current olsrd command-configuration do:\nolsrd show\nTo set the olsrd binary path do:\nolsrd setb /full/path/to/olsrd\nTo start a olsrd instance with a IP address of 10.0.0.1, do:\nolsrd start 10.0.0.1\nTo stop that same instance do:\nolsrd stop 10.0.0.1\nseta would set arguments but is currently not implemented\n",
       ohs_cmd_olsrd
     },
     { NULL, NULL,
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_switch/main.c olsrd-current/src/olsr_switch/main.c
--- olsrd-0.5.0/src/olsr_switch/main.c	2006-11-06 00:03:56.000000000 +0100
+++ olsrd-current/src/olsr_switch/main.c	2007-04-20 16:23:41.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: main.c,v 1.23 2006/11/05 23:03:56 bernd67 Exp $
+ * $Id: main.c,v 1.24 2007/04/20 14:23:41 bernd67 Exp $
  */
 
 /* olsrd host-switch daemon */
@@ -84,7 +84,7 @@
 static int
 ohs_init_new_connection(int);
 
-inline static int
+static int
 ohs_route_data(struct ohs_connection *);
 
 static int
@@ -263,7 +263,7 @@
   return 0;
 }
 
-inline static int
+static int
 ohs_route_data(struct ohs_connection *oc)
 {
   struct ohs_connection *ohs_cs;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_switch/ohs_cmd.c olsrd-current/src/olsr_switch/ohs_cmd.c
--- olsrd-0.5.0/src/olsr_switch/ohs_cmd.c	2005-11-22 11:12:30.000000000 +0100
+++ olsrd-current/src/olsr_switch/ohs_cmd.c	2007-05-31 02:14:53.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ohs_cmd.c,v 1.21 2005/11/22 10:12:30 tlopatic Exp $
+ * $Id: ohs_cmd.c,v 1.22 2007/05/31 00:14:53 ipo23 Exp $
  */
 
 #include "olsr_host_switch.h"
@@ -214,7 +214,8 @@
   /* Set arguments */
   else if(!strncmp(tok_buf, "seta", strlen("seta")))
     {
-
+	printf("Error - NOT IMPLEMENTED YET\n");
+	return 1;
     }
   /* Show settings */
   else if(!strncmp(tok_buf, "show", strlen("show")))
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/olsr_types.h olsrd-current/src/olsr_types.h
--- olsrd-0.5.0/src/olsr_types.h	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/olsr_types.h	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsr_types.h,v 1.5 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: olsr_types.h,v 1.7 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 /*
@@ -50,11 +50,10 @@
 /* types */
 #include <sys/types.h>
 
-typedef enum
-{
+typedef enum {
     OLSR_FALSE = 0,
     OLSR_TRUE
-}olsr_bool;
+} olsr_bool;
 
 #if defined linux || defined __MacOSX__
 
@@ -92,6 +91,9 @@
 
 union olsr_ip_addr
 {
+  /*
+  struct in_addr v4;
+  */
   olsr_u32_t v4;
   olsr_u8_t v4x[4];
   struct in6_addr v6;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/packet.c olsrd-current/src/packet.c
--- olsrd-0.5.0/src/packet.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/packet.c	2007-04-26 00:08:09.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: packet.c,v 1.21 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: packet.c,v 1.22 2007/04/25 22:08:09 bernd67 Exp $
  */
 
 
@@ -94,7 +94,7 @@
   int                     link;
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "\tBuilding HELLO on interface %d\n", outif->if_nr)
+  OLSR_PRINTF(3, "\tBuilding HELLO on interface %d\n", outif->if_nr);
 #endif
 
   message->neighbors=NULL;
@@ -106,7 +106,7 @@
 
   message->willingness = olsr_cnf->willingness;
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Willingness: %d\n", olsr_cnf->willingness)
+  OLSR_PRINTF(3, "Willingness: %d\n", olsr_cnf->willingness);
 #endif
 
   /* Set TTL */
@@ -115,7 +115,7 @@
   COPY_IP(&message->source_addr, &olsr_cnf->main_addr);
 
 #ifdef DEBUG
-      OLSR_PRINTF(5, "On link:\n")
+  OLSR_PRINTF(5, "On link:\n");
 #endif
 
   /* Get the links of this interface */
@@ -193,8 +193,8 @@
       /* Set the main address */
       COPY_IP(&message_neighbor->main_address, &links->neighbor->neighbor_main_addr);
 #ifdef DEBUG
-      OLSR_PRINTF(5, "Added: %s - ", olsr_ip_to_string(&message_neighbor->address))
-      OLSR_PRINTF(5, " status %d\n", message_neighbor->status)
+      OLSR_PRINTF(5, "Added: %s - ", olsr_ip_to_string(&message_neighbor->address));
+      OLSR_PRINTF(5, " status %d\n", message_neighbor->status);
 #endif
       message_neighbor->next=message->neighbors;
       message->neighbors=message_neighbor;	    
@@ -207,7 +207,7 @@
 
 
 #ifdef DEBUG
-      OLSR_PRINTF(5, "Not on link:\n")
+    OLSR_PRINTF(5, "Not on link:\n");
 #endif
 
   /* Add the rest of the neighbors if running on multiple interfaces */
@@ -291,8 +291,8 @@
 
 	    COPY_IP(&message_neighbor->main_address, &neighbor->neighbor_main_addr);
 #ifdef DEBUG
-	    OLSR_PRINTF(5, "Added: %s - ", olsr_ip_to_string(&message_neighbor->address))
-	    OLSR_PRINTF(5, " status  %d\n", message_neighbor->status)
+	    OLSR_PRINTF(5, "Added: %s - ", olsr_ip_to_string(&message_neighbor->address));
+	    OLSR_PRINTF(5, " status  %d\n", message_neighbor->status);
 #endif
 	    message_neighbor->next=message->neighbors;
 	    message->neighbors=message_neighbor;	    
@@ -428,7 +428,7 @@
       if(sending_tc)
 	{
 	  /* Send empty TC */
-	  OLSR_PRINTF(3, "No more MPR selectors - will send empty TCs\n")
+	  OLSR_PRINTF(3, "No more MPR selectors - will send empty TCs\n");
 	  set_empty_tc_timer(GET_TIMESTAMP((olsr_cnf->max_tc_vtime*3)*1000));
 
 	  sending_tc = OLSR_FALSE;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/parser.c olsrd-current/src/parser.c
--- olsrd-0.5.0/src/parser.c	2007-01-31 13:36:50.000000000 +0100
+++ olsrd-current/src/parser.c	2007-05-09 01:34:52.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: parser.c,v 1.32 2007/01/31 12:36:50 bernd67 Exp $
+ * $Id: parser.c,v 1.35 2007/05/08 23:34:52 bernd67 Exp $
  */
 
 #include "parser.h"
@@ -87,9 +87,9 @@
  *@return nada
  */
 void
-olsr_init_parser()
+olsr_init_parser(void)
 {
-  OLSR_PRINTF(3, "Initializing parser...\n")
+  OLSR_PRINTF(3, "Initializing parser...\n");
 
   /* Initialize the packet functions */
   olsr_init_package_process();
@@ -101,7 +101,7 @@
 {
   struct parse_function_entry *new_entry;
 
-  OLSR_PRINTF(3, "Parser: registering event for type %d\n", type)
+  OLSR_PRINTF(3, "Parser: registering event for type %d\n", type);
  
 
   new_entry = olsr_malloc(sizeof(struct parse_function_entry), "Register parse function");
@@ -114,7 +114,7 @@
   new_entry->next = parse_functions;
   parse_functions = new_entry;
 
-  OLSR_PRINTF(3, "Register parse function: Added function for type %d\n", type)
+  OLSR_PRINTF(3, "Register parse function: Added function for type %d\n", type);
 
 }
 
@@ -181,7 +181,7 @@
 
   if (ntohs(olsr->olsr_packlen) != size)
     {
-      OLSR_PRINTF(1, "Size error detected in received packet.\nRecieved %d, in packet %d\n", size, ntohs(olsr->olsr_packlen))
+      OLSR_PRINTF(1, "Size error detected in received packet.\nRecieved %d, in packet %d\n", size, ntohs(olsr->olsr_packlen));
 	    
       olsr_syslog(OLSR_LOG_ERR, " packet length error in  packet received from %s!",
 	     olsr_ip_to_string(from_addr));
@@ -245,7 +245,7 @@
       if(count < 0)
 	{
 	  OLSR_PRINTF(1, "packet length error in  packet received from %s!",
-		      olsr_ip_to_string(from_addr))
+		      olsr_ip_to_string(from_addr));
 
 	  olsr_syslog(OLSR_LOG_ERR, " packet length error in  packet received from %s!",
 		 olsr_ip_to_string(from_addr));
@@ -261,7 +261,7 @@
 	    {
 	      OLSR_PRINTF(2, "Dropping packet type %d from neigh %s with TTL 0\n", 
 			  m->v4.olsr_msgtype,
-			  olsr_ip_to_string(from_addr))
+			  olsr_ip_to_string(from_addr));
 	      continue;
 	    }
 	}
@@ -272,7 +272,7 @@
 	    {
 	      OLSR_PRINTF(2, "Dropping packet type %d from %s with TTL 0\n", 
 			  m->v4.olsr_msgtype,
-			  olsr_ip_to_string(from_addr))
+			  olsr_ip_to_string(from_addr));
 	      continue;
 	    }
 	}
@@ -289,7 +289,7 @@
       if(COMP_IP(&m->v4.originator, &olsr_cnf->main_addr))
 	{
 #ifdef DEBUG
-	  OLSR_PRINTF(3, "Not processing message originating from us!\n")
+	  OLSR_PRINTF(3, "Not processing message originating from us!\n");
 #endif
 	  continue;
 	}
@@ -323,7 +323,7 @@
 	  OLSR_PRINTF(3, "Unknown type: %d, size %d, from %s\n",
 		      m->v4.olsr_msgtype,
 		      size,
-		      olsr_ip_to_string(&unkpacket.originator))
+		      olsr_ip_to_string(&unkpacket.originator));
 
 	  /* Forward message */
 	  if(!COMP_IP(&unkpacket.originator, &olsr_cnf->main_addr))
@@ -369,7 +369,7 @@
     {
       if (32 < ++cpu_overload_exit)
       {
-        OLSR_PRINTF(1, "CPU overload detected, ending olsr_input() loop\n")
+        OLSR_PRINTF(1, "CPU overload detected, ending olsr_input() loop\n");
       	break;
       }
       
@@ -386,7 +386,7 @@
 	{
 	  if (cc < 0 && errno != EWOULDBLOCK)
 	    {
-	      OLSR_PRINTF(1, "error recvfrom: %s", strerror(errno))
+	      OLSR_PRINTF(1, "error recvfrom: %s", strerror(errno));
 	      olsr_syslog(OLSR_LOG_ERR, "error recvfrom: %m");
 	    }
 	  break;
@@ -405,7 +405,7 @@
       
       
 #ifdef DEBUG
-      OLSR_PRINTF(5, "Recieved a packet from %s\n", olsr_ip_to_string((union olsr_ip_addr *)&((struct sockaddr_in *)&from)->sin_addr.s_addr))
+      OLSR_PRINTF(5, "Recieved a packet from %s\n", olsr_ip_to_string((union olsr_ip_addr *)&((struct sockaddr_in *)&from)->sin_addr.s_addr));
 #endif
 	
 	if ((olsr_cnf->ip_version == AF_INET) && (fromlen != sizeof (struct sockaddr_in)))
@@ -421,7 +421,7 @@
 	{
 	  OLSR_PRINTF(1, "Could not find input interface for message from %s size %d\n",
 		      olsr_ip_to_string(&from_addr),
-		      cc)
+		      cc);
 	  olsr_syslog(OLSR_LOG_ERR, "Could not find input interface for message from %s size %d\n",
 		 olsr_ip_to_string(&from_addr),
 		 cc);
@@ -474,7 +474,7 @@
     return;
       
   /* Extract size */
-  if((cc = recv(fd, &pcklen, 2, MSG_PEEK)) != 2)
+  if((cc = recv(fd, (void *)&pcklen, 2, MSG_PEEK)) != 2) /* Win needs a cast */
     {
       if(cc <= 0)
 	{
@@ -502,8 +502,9 @@
     {
       if (cc < 0 && errno != EWOULDBLOCK)
 	{
-	  OLSR_PRINTF(1, "error recvfrom: %s", strerror(errno))
-	    olsr_syslog(OLSR_LOG_ERR, "error recvfrom: %m");
+          const char * const err_msg = strerror(errno);
+	  OLSR_PRINTF(1, "error recvfrom: %s", err_msg);
+          olsr_syslog(OLSR_LOG_ERR, "error recvfrom: %s", err_msg);
 	}
       return;
     }
@@ -518,10 +519,10 @@
     {
       OLSR_PRINTF(1, "Could not find input interface for message from %s size %d\n",
 		  olsr_ip_to_string(&from_addr),
-		  cc)
-	olsr_syslog(OLSR_LOG_ERR, "Could not find input interface for message from %s size %d\n",
-		    olsr_ip_to_string(&from_addr),
-		    cc);
+		  cc);
+      olsr_syslog(OLSR_LOG_ERR, "Could not find input interface for message from %s size %d\n",
+                  olsr_ip_to_string(&from_addr),
+                  cc);
       return;
     }
   
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/plugin_loader.c olsrd-current/src/plugin_loader.c
--- olsrd-0.5.0/src/plugin_loader.c	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-current/src/plugin_loader.c	2007-04-26 00:08:13.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: plugin_loader.c,v 1.23 2005/05/29 12:47:45 br1 Exp $
+ * $Id: plugin_loader.c,v 1.25 2007/04/25 22:08:13 bernd67 Exp $
  */
 
 #include "plugin_loader.h"
@@ -60,22 +60,17 @@
  *@return the number of plugins loaded
  */
 int
-olsr_load_plugins()
+olsr_load_plugins(void)
 {
-  struct plugin_entry *entry;
-  int loaded;
-
-  entry = olsr_cnf->plugins;
-  loaded = 0;
-
-  OLSR_PRINTF(1, "Loading plugins...\n\n")
-
+  struct plugin_entry *entry = olsr_cnf->plugins;
+  int loaded = 0;
+  OLSR_PRINTF(1, "Loading plugins...\n\n");
   while(entry)
     {  
       if(olsr_load_dl(entry->name, entry->params) < 0)
-	OLSR_PRINTF(1, "-- PLUGIN LOADING FAILED! --\n\n")
+	OLSR_PRINTF(1, "-- PLUGIN LOADING FAILED! --\n\n");
       else
-	loaded ++;
+	loaded++;
 
       entry = entry->next;
     }
@@ -98,25 +93,25 @@
   int (*get_interface_version)(void);
   int *interface_version;
 
-  OLSR_PRINTF(1, "---------- Plugin loader ----------\nLibrary: %s\n", libname)
+  OLSR_PRINTF(1, "---------- Plugin loader ----------\nLibrary: %s\n", libname);
 
   if((new_entry.dlhandle = dlopen(libname, RTLD_NOW)) == NULL)
     {
-      OLSR_PRINTF(1, "DL loading failed: \"%s\"!\n", dlerror())
+      OLSR_PRINTF(1, "DL loading failed: \"%s\"!\n", dlerror());
       return -1;
     }
 
   /* Fetch the interface version function, 3 different ways */
-  OLSR_PRINTF(1, "Checking plugin interface version... ")
+  OLSR_PRINTF(1, "Checking plugin interface version... ");
   if((get_interface_version = dlsym(new_entry.dlhandle, "olsrd_plugin_interface_version")) == NULL)
     {
-      OLSR_PRINTF(1, "trying v2 detection... ")
+      OLSR_PRINTF(1, "trying v2 detection... ");
       if((get_interface_version = dlsym(new_entry.dlhandle, "get_plugin_interface_version")) == NULL)
         {
-          OLSR_PRINTF(1, "trying v1 detection... ")
+          OLSR_PRINTF(1, "trying v1 detection... ");
           if((interface_version = dlsym(new_entry.dlhandle, "plugin_interface_version")) == NULL)
             {
-              OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror())
+              OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror());
               dlclose(new_entry.dlhandle);
               return -1;
             }
@@ -134,13 +129,13 @@
     {
       new_entry.plugin_interface_version = get_interface_version();
     }
-  OLSR_PRINTF(1, " %d - OK\n", new_entry.plugin_interface_version)
+  OLSR_PRINTF(1, " %d - OK\n", new_entry.plugin_interface_version);
   
   if ( new_entry.plugin_interface_version < 4 ) 
     {
       /* old plugin interface */
    
-      OLSR_PRINTF(1, "\nWARNING: YOU ARE USING AN OLD DEPRECATED PLUGIN INTERFACE! DETECTED VERSION %d CURRENT VERSION %d\nPLEASE UPGRADE YOUR PLUGIN!\nWILL CONTINUE IN 5 SECONDS...\n\n", new_entry.plugin_interface_version, OLSRD_PLUGIN_INTERFACE_VERSION)
+      OLSR_PRINTF(1, "\nWARNING: YOU ARE USING AN OLD DEPRECATED PLUGIN INTERFACE! DETECTED VERSION %d CURRENT VERSION %d\nPLEASE UPGRADE YOUR PLUGIN!\nWILL CONTINUE IN 5 SECONDS...\n\n", new_entry.plugin_interface_version, OLSRD_PLUGIN_INTERFACE_VERSION);
       
       sleep(5);
       dlclose(new_entry.dlhandle);
@@ -152,30 +147,30 @@
       
       if ( new_entry.plugin_interface_version != OLSRD_PLUGIN_INTERFACE_VERSION ) 
         {
-          OLSR_PRINTF(1, "\n\nWARNING: VERSION MISSMATCH! DETECTED %d CURRENT VERSION %d\nTHIS CAN CAUSE UNEXPECTED BEHAVIOUR AND CRASHES!\nWILL CONTINUE IN 5 SECONDS...\n\n", get_interface_version(), OLSRD_PLUGIN_INTERFACE_VERSION)
+          OLSR_PRINTF(1, "\n\nWARNING: VERSION MISSMATCH! DETECTED %d CURRENT VERSION %d\nTHIS CAN CAUSE UNEXPECTED BEHAVIOUR AND CRASHES!\nWILL CONTINUE IN 5 SECONDS...\n\n", get_interface_version(), OLSRD_PLUGIN_INTERFACE_VERSION);
           sleep(5);
         }
    
       /* Fetch the init function */
-      OLSR_PRINTF(1, "Trying to fetch plugin init function... ")
+      OLSR_PRINTF(1, "Trying to fetch plugin init function... ");
       if((new_entry.plugin_init = dlsym(new_entry.dlhandle, "olsrd_plugin_init")) == NULL)
         {
-          OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror())
+          OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror());
           dlclose(new_entry.dlhandle);
           return -1;
         }
       else
 	{
-	  OLSR_PRINTF(1, "OK\n")	
+	  OLSR_PRINTF(1, "OK\n");
 	}
     }
 
   /* Fetch the parameter function */
-  OLSR_PRINTF(1, "Trying to fetch param function... ")
+  OLSR_PRINTF(1, "Trying to fetch param function... ");
   if((new_entry.register_param = dlsym(new_entry.dlhandle, "olsrd_plugin_register_param")) == NULL)
-    OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror())
+    OLSR_PRINTF(1, "FAILED: \"%s\"\n", dlerror());
   else
-    OLSR_PRINTF(1, "OK\n")
+    OLSR_PRINTF(1, "OK\n");
 
   entry = olsr_malloc(sizeof(struct olsr_plugin), "Plugin entry");
   memcpy(entry, &new_entry, sizeof(struct olsr_plugin));
@@ -188,7 +183,7 @@
   entry->next = olsr_plugins;
   olsr_plugins = entry;
 
-  OLSR_PRINTF(1, "---------- LIBRARY LOADED ----------\n\n")
+  OLSR_PRINTF(1, "---------- LIBRARY LOADED ----------\n\n");
 
   return 0;
 }
@@ -207,27 +202,24 @@
 void
 init_olsr_plugin(struct olsr_plugin *entry)
 {
-  struct plugin_param *params = entry->params;
-  int retval;
-
   if(entry->register_param)
     {
-      OLSR_PRINTF(1, "Sending parameters...\n")
-      while(params)
+      struct plugin_param *params;
+      OLSR_PRINTF(1, "Sending parameters...\n");
+        for(params = entry->params;params;params = params->next)
         {
-          OLSR_PRINTF(1, "\"%s\"/\"%s\"... ", params->key, params->value)
-          if((retval = entry->register_param(params->key, params->value)) < 0)
+          int retval = entry->register_param(params->key, params->value);
+          OLSR_PRINTF(1, "\"%s\"/\"%s\"... ", params->key, params->value);
+          if(retval < 0)
             {
               fprintf(stderr, "\nFatal error in plugin parameter \"%s\"/\"%s\"\n", params->key, params->value);
               exit(EXIT_FAILURE);
             }
-          OLSR_PRINTF(1, "%s\n", retval == 0 ? "FAILED" : "OK")
-
-          params = params->next;
+          OLSR_PRINTF(1, "%s\n", retval == 0 ? "FAILED" : "OK");
         }
     }
     
-    OLSR_PRINTF(1, "Running plugin_init function...\n")
+  OLSR_PRINTF(1, "Running plugin_init function...\n");
     entry->plugin_init();
 }
 
@@ -236,15 +228,11 @@
  *Close all loaded plugins
  */
 void
-olsr_close_plugins()
+olsr_close_plugins(void)
 {
   struct olsr_plugin *entry;
 
-  OLSR_PRINTF(1, "Closing plugins...\n")
-  for(entry = olsr_plugins; 
-      entry != NULL ; 
-      entry = entry->next)
-    {
+  OLSR_PRINTF(1, "Closing plugins...\n");
+  for(entry = olsr_plugins; entry != NULL; entry = entry->next)
       dlclose(entry->dlhandle);
-    }
 }
